#include "dynarray.h"
#include "token.h"
#include <util.h>
#include <tokeniser.h>
#include <stdio.h>

int main(int argc, const char** argv) {
    if (argc < 2) {
        printf("Usage: %s [source]\n", argv[0]);
        return 1;
    }
    char* str = read_to_string(argv[1]);
    token_t* tokens = tokenise_string((char*)argv[1], str);
    int token_count = dynarray_length(tokens);

    for (int i = 0; i < token_count; i++) {
        token_t tok = tokens[i];
        switch (tok.type) {
        case (TT_NONE):
            break;
        case (TT_KW): {
            printf("TOK: KW %s\n", KW_LIST[tok.kw_type]);
        } break;
        case (TT_OP): {
            printf("TOK: OP %s\n", OP_LIST[tok.op_type]);
        } break;
        case (TT_IDENT): {
            printf("TOK: IDENT \"%s\"\n", tok.str_v);
        } break;
        case (TT_PUSH_INT): {
            printf("TOK: PUSH_INT \"%zu\"\n", tok.int_v);
        } break;
        default:
            break;
        }
    }

    return 0;
}
